from datetime import datetime


@service
def epg_timer():
    
    #--- update input_text.epg_date and input_text.epg_time every minute ---
    fulldatetime = datetime.now()

    #--- date part ---
    epgdate = str(fulldatetime.year)
    epgmonth = "00" + str(fulldatetime.month)
    epgday = "00" + str(fulldatetime.day)
    epgdate = epgdate + epgmonth[-2:]
    epgdate = epgdate + epgday[-2:]
    
    #--- time part ---
    epghour = int(fulldatetime.hour)
    epgminute = int(fulldatetime.minute)
    
    #--- logic for setting minutes to 00 or 30, depending on the current time ---
    if epgminute < 16:
        rightpart = "00"
    if epgminute > 45:
        rightpart = "00"
        epghour = epghour + 1
        if epghour > 23:
            epghour = 1
    if epgminute > 15 and epgminute < 46:
        rightpart = "30"
        
    epghour = "00" + str(epghour)
    epghour = epghour[-2:]
    epgtime = epghour + rightpart
    epgurl = "https://192.168.123.88:8123/local/epg/" + epgdate + ".html#" + epgtime
    
    #--- set date and time to their corresponding input_text sensors ---
    input_text.set_value(entity_id="input_text.epg_url", value=epgurl)
    input_text.set_value(entity_id="input_text.epg_date",value=epgdate)
    input_text.set_value(entity_id="input_text.epg_time",value=epgtime)
